﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Data.Entity
Imports CodeFirstSample.PersonService
Imports System.Xml.Linq
Imports System.IO

    Friend Class Program
        Shared Sub Main(ByVal args() As String)
        'QueryPerson()
        'InsertPerson()
            InsertPersonNoLastName()
        'InsertMultiplePersonNoLastName()

        End Sub

        Private Shared Sub QueryPerson()
            'verify service is accessible
            Dim context = New PersonModelContext(New Uri("http://localhost:43447/DataService.svc"))
            Try
                Dim people = context.People.ToList()
                Console.WriteLine("Success: " & people.Count.ToString() & " retrieved")
            Catch ex As Exception
                Console.WriteLine("Query Failed")
                If ex.InnerException IsNot Nothing Then
                    Console.WriteLine("Inner Exception: " & ex.InnerException.Message)
                End If
            Finally
                FinishConsole()
            End Try
        End Sub

        'verify that VALID insert succeeds
        Private Shared Sub InsertPerson()
            Dim person = New Person With {.FirstName = "Julie", .LastName = "Lerman", .IdentityCardNumber = "12345678"}
        Dim context = New PersonModelContext(New Uri("http://localhost:27121/DataService.svc"))

            context.AddToPeople(person)
            Try
                context.SaveChanges()
                Console.WriteLine("Successful Insert")
            Catch ex As Exception
                Console.WriteLine("Insert Failed")
                If ex.InnerException IsNot Nothing Then
                    Console.WriteLine("Inner Exception: " & ex.InnerException.Message)
                End If
            Finally
                FinishConsole()
            End Try
        End Sub


        Private Shared Sub InsertPersonNoLastName()
            Dim person = New Person With {.FirstName = "Julie", .IdentityCardNumber = "123456789ABCDE"}
        Dim context = New PersonModelContext(New Uri("http://localhost:27121/DataService.svc"))


            context.AddToPeople(person)

            Try
                context.SaveChanges()
            Console.WriteLine("Insert Succeeded -- but that means this little test failed!")

            Catch ex As Exception
                Dim sr = New StringReader(ex.InnerException.Message)
                Dim root As XElement = XElement.Load(sr)
                Dim message As IEnumerable(Of XElement) = From el In root.Elements()
                                                          Where el.Name.LocalName = "message"
                                                          Select el
            For Each el In message
                Console.WriteLine(el.Value)
            Next el
            Finally
                FinishConsole()
            End Try
        End Sub

        Private Shared Sub InsertMultiplePersonNoLastName()
            Dim person = New Person With {.FirstName = "Julie", .IdentityCardNumber = "123456789ABCDE"}
            Dim person2 = New Person With {.FirstName = "Rich", .IdentityCardNumber = "987654321EDCBA"}
            Dim context = New PersonModelContext(New Uri("http://localhost:43447/DataService.svc"))


            context.AddToPeople(person)
            context.AddToPeople(person2)

            Try
                context.SaveChanges()
                Console.WriteLine("Insert Succeeded -- but that means this little test failed!")


            Catch ex As Exception
                Dim sr = New StringReader(ex.InnerException.Message)
                Dim root As XElement = XElement.Load(sr)
                Dim message As IEnumerable(Of XElement) = From el In root.Elements()
                                                          Where el.Name.LocalName = "message"
                                                          Select el
            For Each el In message
                Console.WriteLine(el.Value)
            Next el

                Console.ReadKey()
            Finally
                FinishConsole()
            End Try
        End Sub

        Private Shared Sub FinishConsole()
            Console.WriteLine("Press any key to end ...")
            Console.ReadKey()
        End Sub
    End Class
