﻿Imports System.Data.Services
Imports System.Data.Services.Common
Imports DataAccessMSDN
Imports System.Data.Entity
Imports System.Reflection
Imports System.Linq
Imports System.Text

    Public Class DataService
        Inherits DataService(Of PersonModelContext)
        Public Shared Sub InitializeService(ByVal config As DataServiceConfiguration)
            config.UseVerboseErrors = True
            config.SetEntitySetAccessRule("People", EntitySetRights.All)
            config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V3
        End Sub


        Protected Overrides Sub HandleException(ByVal args As HandleExceptionArgs)
#If False Then
	  If args.Exception.GetType() Is GetType(TargetInvocationException) AndAlso args.Exception.InnerException IsNot Nothing Then
		If args.Exception.InnerException.GetType() Is GetType(DataServiceException) Then

		  ' Unpack the DataServiceException.
		  args.Exception = TryCast(args.Exception.InnerException, DataServiceException)

		Else
		  ' Return a new DataServiceException as "400: bad request."
		  args.Exception = New DataServiceException(400, args.Exception.InnerException.Message)
		End If
	  End If
#End If
            If args.Exception.GetType() Is GetType(System.Data.Entity.Validation.DbEntityValidationException) Then
                Dim ve = TryCast(args.Exception, System.Data.Entity.Validation.DbEntityValidationException)

                Dim errorsForOneObject = ve.EntityValidationErrors.First().ValidationErrors.ToList()
            Dim errorMessage = New StringBuilder
                For Each e As System.Data.Entity.Validation.DbValidationError In errorsForOneObject
                    errorMessage.AppendLine(e.ErrorMessage)
                Next e
                args.Exception = New DataServiceException(errorMessage.ToString())
            End If
        End Sub
    End Class
